

      module system_mod
!
      contains
!
!


!
! (c) sparslab module name=realli_a
!
! purpose:
!  reallocate an integer array.
!
! history:
!   original version for sparslab - tu - 16/04/2001.
!
      subroutine realli_a(ja,arrsize,arrincr,new_arrsize,ierr)
!
! parameters
!
      integer arrsize,arrincr,new_arrsize,ierr
      integer, allocatable, dimension(:) :: ja
!
! internals
!
      integer minincr
      integer, allocatable, dimension(:) :: ja_new
      double precision minincrfactor
      parameter(minincrfactor=0.2d0)
!
! start of realli_a
!
      new_arrsize=arrsize+arrincr
      if(new_arrsize.le.arrsize) then
        minincr=int(minincrfactor*dble(arrsize))
        new_arrsize=arrsize+minincr
        if(new_arrsize.le.arrsize) new_arrsize=huge(arrsize)
      end if
      allocate(ja_new(arrsize),stat=ierr)
      if(ierr.ne.0) call serr(0,2,'sparslab','realli_a', &
        ' Allocation failure',1605,2)
      call iwcopy(arrsize,ja,1,ja_new,1)
      deallocate(ja)
      allocate(ja(new_arrsize),stat=ierr)
      if(ierr.ne.0) call serr(0,2,'sparslab','realli_a', &
        ' Allocation failure',1605,2)
      call iwcopy(arrsize,ja_new,1,ja,1)
      deallocate(ja_new)
!
!  -- return
!
      return
!
! end of realli_a
!
      end subroutine realli_a
!


!

! (c) sparslab module name=reallr_a
!
! purpose:
!  reallocate an integer array.
!
! history:
!   original version for sparslab - tu - 16/04/2001.
!
      subroutine reallr_a(aa,arrsize,arrincr,new_arrsize,ierr)
!
! parameters
!
      use iotypes
      integer arrsize,arrincr,new_arrsize,ierr
      double precision, allocatable, dimension(:) :: aa
!
! internals
!
      integer minincr
      double precision, allocatable, dimension(:) :: aa_new
      double precision minincrfactor
      parameter(minincrfactor=0.2d0)
      character i_am*10
!
! start of reallr_a
!
      i_am='reallr_a'
!      write(2,*) 'arrsize',arrsize,arrincr
      new_arrsize=arrsize+arrincr
!      write(2,*) 'arrsize',new_arrsize
      if(new_arrsize.le.arrsize) then
        minincr=int(minincrfactor*dble(arrsize))
        new_arrsize=arrsize+minincr
!      write(2,*) 'arrsize',minincr,new_arrsize
        if(new_arrsize.le.arrsize) new_arrsize=huge(arrsize)
      end if
      allocate(aa_new(arrsize),stat=ierr)
!      write(2,*) 'ierr',ierr
      if(ierr.ne.0) call err(ounit,1605,i_am,2)
      call dcopy(arrsize,aa,1,aa_new,1)
      deallocate(aa)
      allocate(aa(new_arrsize),stat=ierr)
!      write(2,*) 'ierr huhu',new_arrsize,ierr
      if(ierr.ne.0) call err(ounit,1605,i_am,2)
      call dcopy(arrsize,aa_new,1,aa,1)
      deallocate(aa_new)
!
!  -- return
!
      return
!
! end of reallr_a
!
      end subroutine reallr_a
!


! (c) sparslab module name=realli3_a
!
! purpose:
!  reallocate an integer array.
!  counts with additional nlast entries.
!
! history:
!   original version for sparslab - tu - 16/04/2001.
!
      subroutine realli3_a(ja,arrsize,arrincr,new_arrsize,nlast,ierr)
!
! parameters
!
      integer arrsize,arrincr,new_arrsize,ierr,nlast
      integer, allocatable, dimension(:) :: ja
!
! internals
!
      integer minincr
      integer, allocatable, dimension(:) :: ja_new
      double precision minincrfactor
      parameter(minincrfactor=0.2d0)
!
! start of realli3_a
!
      new_arrsize=arrsize+arrincr
      if(new_arrsize.le.arrsize) then
        minincr=int(minincrfactor*dble(arrsize))
        new_arrsize=arrsize+minincr
        if(new_arrsize.le.arrsize) new_arrsize=huge(arrsize)
      end if
      allocate(ja_new(arrsize+nlast),stat=ierr)
      if(ierr.ne.0) call serr(0,2,'sparslab','realli3_a', &
        ' Allocation failure',1605,2)
      call iwcopy(arrsize+nlast,ja,1,ja_new,1)
      deallocate(ja)
      allocate(ja(new_arrsize+nlast),stat=ierr)
      if(ierr.ne.0) call serr(0,2,'sparslab','realli3_a', &
        ' Allocation failure',1605,2)
      call iwcopy(arrsize,ja_new,1,ja,1)
      call ivcopy_backward(nlast,ja_new,ja, &
        arrsize+1,new_arrsize+1)
      deallocate(ja_new)
!
!  -- return
!
      return
!
! end of realli3_a
!
      end subroutine realli3_a

! (c) sparslab module name=reallr3_a
!
! purpose:
!  reallocate an integer array.
!
! history:
!   original version for sparslab - tu - 16/04/2001.
!
      subroutine reallr3_a(aa,arrsize,arrincr,new_arrsize,nlast,ierr)
!
! parameters
!
      use iotypes
      integer arrsize,arrincr,new_arrsize,nlast,ierr
      double precision, allocatable, dimension(:) :: aa
!
! internals
!
      integer minincr
      double precision, allocatable, dimension(:) :: aa_new
      double precision minincrfactor
      parameter(minincrfactor=0.2d0)
      character i_am*10
!
! start of reallr3_a
!
      i_am='reallr3_a'
      new_arrsize=arrsize+arrincr
      if(new_arrsize.le.arrsize) then
        minincr=int(minincrfactor*dble(arrsize))
        new_arrsize=arrsize+minincr
        if(new_arrsize.le.arrsize) new_arrsize=huge(arrsize)
      end if
      allocate(aa_new(arrsize+nlast),stat=ierr)
      if(ierr.ne.0) call err(ounit,1605,i_am,2)
      call dcopy(arrsize+nlast,aa,1,aa_new,1)
      deallocate(aa)
      allocate(aa(new_arrsize+nlast),stat=ierr)
      if(ierr.ne.0) call err(ounit,1605,i_am,2)
      call dcopy(arrsize,aa_new,1,aa,1)
      call dvcopy_backward(nlast,aa_new,aa, &
        arrsize+1,new_arrsize+1)
      deallocate(aa_new)
!
!  -- return
!
      return
!
! end of reallr3_a
!
      end subroutine reallr3_a

!
      end module system_mod



      module matrix90
!
      use system_mod
!
      contains
!
!


! (c) sparslab module name=dsinit
!
! purpose:
!   initialization of dynamic data structures.
!   used typically for right-looking implementations
!   input matrix is in csr format.
!
! history:
!   original version for sparslab - tu - 13/04/1996.
!
! parameters:
!  ii  n  number of input matrix columns.
!  ii  m  number of input matrix rows.
!  gi  ia(n+1)/ja(ia(nn+1)-1) input matrix pattern
!  mo  ic(n)/jc(ic(n)+lenc(n)-1)/lenc(n)/ac(ic(n)+lenc(n)-1) output unit
!        matrix in dsc format.
!  ii  max_c  size of the vectors jc/ac.
!  mo  ir(n)/jr(ir(n)+lenr(n)-1)/lenr(n) output graph of unit matrix
!        in dsr format.
!  ii  max_r  size of the vector jr.
!  io  iendru  position of last entry in ir/jr/lenr.
!  io  iendlu  position of last entry in ic/jc/lenc/ac.
!  ii  idistr  type of the distribution pattern of the dsc format.
!  ii  idistc  type of the distribution pattern of the dsr format.
!  ii  ldist   distance between entries in ds* formats.
!
      subroutine dsinit(n,m,ia,ja,ic,jc,lenc,ac,max_c, &
        ir,jr,lenr,max_r, &
        iendru,iendlu,idistr,idistc,ldist,info)
!
! parameters
!
      integer n,m,max_r,max_c,ldist,info
      integer idistr,idistc,len
      integer :: ia(*),ja(*)
      integer, allocatable :: ir(:),jr(:),lenr(:),ic(:),jc(:),lenc(:)
      double precision, allocatable :: ac(:)
      integer iendru,iendlu
!
! include
!
! internals
!
      integer i,j,k,l,jstrt,jstop,nja
      integer izero
      double precision one
      parameter(izero=0,one=1.0d0)
!
! start of dsinit
!
!  -- test/set max_r and max_c
!
      info=0
      nja=ia(n+1)-1
      if(idistc.eq.1) then
!
!  -- search the matrix rows
!  -- not necessary if appropriate pointers are passed from
!  -- the matrix stored in a triangle
!  -- the input matrix in ia/ja/a should be partially ordered
!
        if(ia(n+1)-1+n*ldist.ge.max_c-1) then
          max_c=2*nja+n*ldist
          deallocate(jc,ac)
          allocate(ac(max_c),jc(max_c),stat=ierr)
          if(ierr.ne.0) then
            info=1603
            return
          end if
        end if
      end if
      if(idistr.eq.1) then
!
!  -- search the matrix rows
!  -- not necessary if appropriate pointers are passed from
!  -- the matrix stored in a triangle
!  -- the input matrix in ia/ja/a should be partially ordered
!
        if(ia(m+1)-1+n*ldist.ge.max_r-1) then
          max_r=2*nja+n*ldist
          deallocate(jr)
          allocate(jr(max_r),stat=ierr)
          if(ierr.ne.0) call serr(0,2,'sparslab','dsinit', &
            ' missing space to store the preconditioner',1603,2)
        end if
      end if
!
!  -- clear vectors for row and column indices
!
      call iwset(max_r-1,izero,jr,1)
      jr(max_r)=1
      call iwset(max_c-1,izero,jc,1)
      jc(max_c)=1
!
!  -- set column pointers
!  -- and insert an unit matrix stored by columns
!
      if(idistc.eq.0.or.idistc.eq.2) then
        if(idistc.eq.0) then
          len=1
          iendlu=len*(m-1)+1
        elseif(idistc.eq.2) then
          i=max_c/3
          len=max(1,i/m)
          iendlu=len*(m-1)+1
        end if
!
!    -- set initial values in the distance len
!
        k=1
        do i=1,n
          ic(i)=k
          lenc(i)=1
          jc(k)=i
          ac(k)=one
          k=k+len
        end do
      elseif(idistc.eq.1) then
        k=1
        do i=1,n
          jstrt=ia(i)
          jstop=ia(i+1)-1
          len=jstop-jstrt+1
          do j=jstrt,jstop
            l=ja(j)
            if(l.eq.i) then
              len=j-jstrt+1
              go to 130
            end if
          end do
 130      continue
          ic(i)=k
          lenc(i)=1
          jc(k)=i
          ac(k)=one
          k=k+len+ldist
        end do
        iendlu=k-len-ldist
      end if
      if(iendlu.ge.max_c-1) then
        stop 'internal error'
      end if
!
!  -- set row pointers
!  -- and insert row structure of the unit matrix
!
      if(idistr.eq.0.or.idistr.eq.2) then
        if(idistr.eq.0) then
          len=1
          iendru=len*(m-1)+1
        elseif(idistr.eq.2) then
          i=max_r/3
          len=max(1,i/m)
          iendru=len*(m-1)+1
        end if
!
!    -- set initial values
!
        k=1
        do i=1,m
          ir(i)=k
          lenr(i)=1
          jr(k)=i
          k=k+len
        end do
      elseif(idistr.eq.1) then
        k=1
        do i=1,m
          jstrt=ia(i)
          jstop=ia(i+1)-1
          len=jstop-jstrt+1
          do j=jstrt,jstop
            l=ja(j)
            if(l.eq.i) then
              len=jstop-j+1
              exit
            end if
          end do
          ir(i)=k
          lenr(i)=1
          jr(k)=i
          k=k+len+ldist
        end do
        iendru=k-len-ldist
      end if
      if(iendru.ge.max_r-1) then
        stop 'internal error'
      end if
!
!  -- return
!
      return
!
! end of dsinit
!
      end subroutine dsinit


! (c) sparslab module name=ds_eye_f90_mod
!
! purpose:
!   initialization of dynamic data structures for right-looking
!   ainv preconditioner.
!   input matrix is in csr format.
!
! history:
!   original version for sparslab - tu - 13/04/1996.
!
! parameters:
!  ii  n  number of input matrix columns.
!  ii  m  number of input matrix rows.
!  gi  ia(n+1)/ja(ia(nn+1)-1) input matrix graph.
!  mo  ic(n)/jc(ic(n)+kc(n)-1)/kc(n)/ac(ic(n)+kc(n)-1) output unit
!        matrix in dsc format.
!  ii  max_c  size of the vectors jc/ac.
!  mo  ir(n)/jr(ir(n)+kr(n)-1)/kr(n) output graph of unit matrix
!        in dsr format.
!  ii  max_r  size of the vector jr.
!  io  iendru  position of last entry in ir/jr/kr.
!  io  iendlu  position of last entry in ic/jc/kc/ac.
!  ii  idistr  type of the distribution pattern of the dsc format.
!  ii  idistc  type of the distribution pattern of the dsr format.
!  ii  lsize  size of the distance between entries in ds* formats.
!
!
! make_explicit_interface
!
      subroutine ds_eye_f90_mod(n,m,ia,ja,ic,jc,kc,ac,max_c, &
        ir,jr,kr,max_r,                                      &
        iendru,iendlu,idistr,idistc,lsize,ierr)
!
! parameters
!
      implicit none
      integer n,m,max_r,max_c,lsize,ierr
      integer idistr,idistc,len
      integer :: ia(*),ja(*)
      integer, allocatable :: ir(:),jr(:),kr(:),ic(:),jc(:),kc(:)
      double precision, allocatable :: ac(:)
      integer iendru,iendlu
!
! include
!
! internals
!
      integer i,j,k,l,jstrt,jstop,nja
      integer izero
      double precision one
      parameter(izero=0,one=1.0d0)
!
! start of ds_eye_f90_mod
!
!  -- test/set max_r and max_c
!
      nja=ia(n+1)-1
      if(idistc.eq.1) then
!
!  -- search the matrix rows
!  -- not necessary if appropriate pointers are passed from
!  -- the matrix stored in a triangle
!  -- the input matrix in ia/ja/a should be partially ordered
!
        if(ia(n+1)-1+n*lsize.ge.max_c-1) then
          max_c=2*nja+n*lsize
          deallocate(ac)
          allocate(ac(max_c),stat=ierr)
          if(ierr.ne.0) call serr(0,2,'sparslab','ds_eye_f90_mod', &
            ' missing space to store the preconditioner',1603,2)
          deallocate(jc)
          allocate(jc(max_c),stat=ierr)
          if(ierr.ne.0) call serr(0,2,'sparslab','ds_eye_f90_mod', &
            ' missing space to store the preconditioner',1603,2)
        end if
      end if
      if(idistr.eq.1) then
!
!  -- search the matrix rows
!  -- not necessary if appropriate pointers are passed from
!  -- the matrix stored in a triangle
!  -- the input matrix in ia/ja/a should be partially ordered
!
        if(ia(m+1)-1+n*lsize.ge.max_r-1) then
          max_r=2*nja+n*lsize
          deallocate(jr)
          allocate(jr(max_r),stat=ierr)
          if(ierr.ne.0) call serr(0,2,'sparslab','ds_eye_f90_mod', &
            ' missing space to store the preconditioner',1603,2)
        end if
      end if
!
!  -- clear vectors for row and column indices
!
      call iwset(max_r-1,izero,jr,1)
      jr(max_r)=1
      call iwset(max_c-1,izero,jc,1)
      jc(max_c)=1
!
!  -- set column pointers
!  -- and insert an unit matrix stored by columns
!
      if(idistc.eq.0.or.idistc.eq.2) then
        if(idistc.eq.0) then
          len=1
          iendlu=len*(m-1)+1
        elseif(idistc.eq.2) then
          i=max_c/3
          len=max(1,i/m)
          iendlu=len*(m-1)+1
        end if
!
!    -- set initial values in the distance len
!
        k=1
        do i=1,n
          ic(i)=k
          kc(i)=1
          jc(k)=i
          ac(k)=one
          k=k+len
        end do
      elseif(idistc.eq.1) then
        k=1
        do i=1,n
          jstrt=ia(i)
          jstop=ia(i+1)-1
          len=jstop-jstrt+1
          do j=jstrt,jstop
            l=ja(j)
            if(l.eq.i) then
              len=j-jstrt+1
              exit
            end if
          end do
          ic(i)=k
          kc(i)=1
          jc(k)=i
          ac(k)=one
          k=k+len+lsize
        end do
        iendlu=k-len-lsize
      end if
      if(iendlu.ge.max_c-1) then
        stop 'internal error'
      end if
!
!  -- set row pointers
!  -- and insert row structure of the unit matrix
!
      if(idistr.eq.0.or.idistr.eq.2) then
        if(idistr.eq.0) then
          len=1
          iendru=len*(m-1)+1
        elseif(idistr.eq.2) then
          i=max_r/3
          len=max(1,i/m)
          iendru=len*(m-1)+1
        end if
!
!    -- set initial values
!
        k=1
        do i=1,m
          ir(i)=k
          kr(i)=1
          jr(k)=i
          k=k+len
        end do
      elseif(idistr.eq.1) then
        k=1
        do i=1,m
          jstrt=ia(i)
          jstop=ia(i+1)-1
          len=jstop-jstrt+1
          do j=jstrt,jstop
            l=ja(j)
            if(l.eq.i) then
              len=jstop-j+1
              exit
            end if
          end do
          ir(i)=k
          kr(i)=1
          jr(k)=i
          k=k+len+lsize
        end do
        iendru=k-len-lsize
      end if
      if(iendru.ge.max_r-1) then
        stop 'internal error'
      end if
!
!  -- return
!
      return
!
! end of ds_eye_f90_mod
!
      end subroutine ds_eye_f90_mod


! (c) sparslab module name=ds_eye_mod
!
! purpose:
!   initialization of dynamic data structures for right-looking
!   ainv preconditioner.
!   input matrix is in csr format.
!
! history:
!   original version for sparslab - tu - 13/04/1996.
!
! parameters:
!  ii  n  number of input matrix columns.
!  ii  m  number of input matrix rows.
!  gi  ia(n+1)/ja(ia(nn+1)-1) input matrix graph.
!  mo  ic(n)/jc(ic(n)+kc(n)-1)/kc(n)/ac(ic(n)+kc(n)-1) output unit
!        matrix in dsc format.
!  ii  max_c  size of the vectors jc/ac.
!  mo  ir(n)/jr(ir(n)+kr(n)-1)/kr(n) output graph of unit matrix
!        in dsr format.
!  ii  max_r  size of the vector jr.
!  io  iendru  position of last entry in ir/jr/kr.
!  io  iendlu  position of last entry in ic/jc/kc/ac.
!  ii  idistr  type of the distribution pattern of the dsc format.
!  ii  idistc  type of the distribution pattern of the dsr format.
!  ii  lsize  size of the distance between entries in ds* formats.
!
      subroutine ds_eye_mod(n,m,ia,ja,ic,jc,kc,ac,max_c,ir,jr,kr,max_r, &
        iendru,iendlu,idistr,idistc,lsize,ierr)
!
! parameters
!
      integer n,m,max_r,max_c,lsize,ierr
      integer idistr,idistc,len
      integer :: ia(*),ja(*)
      integer, allocatable :: ir(:),jr(:),kr(:),ic(:),jc(:),kc(:)
      double precision, allocatable :: ac(:)
      integer iendru,iendlu
!
! include
!
! internals
!
      integer i,j,k,l,jstrt,jstop,nja
      integer izero
      double precision one
      parameter(izero=0,one=1.0d0)
!
! start of ds_eye_mod
!
!  -- test/set max_r and max_c
!
      nja=ia(n+1)-1
      len=1
      if(idistc.eq.1) then
!
!  -- search the matrix rows
!  -- not necessary if appropriate pointers are passed from
!  -- the matrix stored in a triangle
!  -- the input matrix in ia/ja/a should be partially ordered
!
        if(ia(n+1)-1+n*lsize.ge.max_c-1) then
          max_c=2*nja+n*lsize
          deallocate(ac)
          allocate(ac(max_c),stat=ierr)
          if(ierr.ne.0) call serr(0,2,'sparslab','ds_eye_mod', &
            ' missing space to store the preconditioner',1603,2)
          deallocate(jc)
          allocate(jc(max_c),stat=ierr)
          if(ierr.ne.0) call serr(0,2,'sparslab','ds_eye_mod', &
            ' missing space to store the preconditioner',1603,2)
        end if
      end if
      if(idistr.eq.1) then
!
!  -- search the matrix rows
!  -- not necessary if appropriate pointers are passed from
!  -- the matrix stored in a triangle
!  -- the input matrix in ia/ja/a should be partially ordered
!
        if(ia(m+1)-1+n*lsize.ge.max_r-1) then
          max_r=2*nja+n*lsize
          deallocate(jr)
          allocate(jr(max_r),stat=ierr)
          if(ierr.ne.0) call serr(0,2,'sparslab','ds_eye_mod',  &
            ' missing space to store the preconditioner',1603,2)
        end if
      end if
!
!  -- clear vectors for row and column indices
!
      call iwset(max_r-1,izero,jr,1)
      jr(max_r)=1
      call iwset(max_c-1,izero,jc,1)
      jc(max_c)=1
!
!  -- set column pointers
!  -- and insert an unit matrix stored by columns
!
      if(idistc.eq.0.or.idistc.eq.2) then
        if(idistc.eq.0) then
          len=1
          iendlu=len*(m-1)+1
        elseif(idistc.eq.2) then
          i=max_c/3
          len=max(1,i/m)
          iendlu=len*(m-1)+1
        end if
!
!    -- set initial values in the distance len
!
        k=1
        do i=1,n
          ic(i)=k
          kc(i)=1
          jc(k)=i
          ac(k)=one
          k=k+len
        end do
      elseif(idistc.eq.1) then
        k=1
        do i=1,n
          jstrt=ia(i)
          jstop=ia(i+1)-1
          len=jstop-jstrt+1
          do j=jstrt,jstop
            l=ja(j)
            if(l.eq.i) then
              len=j-jstrt+1
              go to 130
            end if
          end do
 130 &
          continue
          ic(i)=k
          kc(i)=1
          jc(k)=i
          ac(k)=one
          k=k+len+lsize
        end do
        iendlu=k-len-lsize
      end if
      if(iendlu.ge.max_c-1) then
        stop 'internal error'
      end if
!
!  -- set row pointers
!  -- and insert row structure of the unit matrix
!
      if(idistr.eq.0.or.idistr.eq.2) then
        if(idistr.eq.0) then
          len=1
          iendru=len*(m-1)+1
        elseif(idistr.eq.2) then
          i=max_r/3
          len=max(1,i/m)
          iendru=len*(m-1)+1
        end if
!
!    -- set initial values
!
        k=1
        do i=1,m
          ir(i)=k
          kr(i)=1
          jr(k)=i
          k=k+len
        end do
      elseif(idistr.eq.1) then
        k=1
        do i=1,m
          jstrt=ia(i)
          jstop=ia(i+1)-1
          len=jstop-jstrt+1
          do j=jstrt,jstop
            l=ja(j)
            if(l.eq.i) then
              len=jstop-j+1
              exit
            end if
          end do
          ir(i)=k
          kr(i)=1
          jr(k)=i
          k=k+len+lsize
        end do
        iendru=k-len-lsize
      end if
      if(iendru.ge.max_r-1) then
        stop 'internal error'
      end if
!
!  -- return
!
      return
!
! end of ds_eye_mod
!
      end subroutine ds_eye_mod



! (c) sparslab module name=csr2dsc_mod
!
! purpose:
!  matrix conversion from csr format
!  into dsc format with sufficient elbow space.
!
! history:
!   original version for sparslab - tu - 04/05/2001.
!
! parameters:
!   ii  n  matrix dimension.
!   oi  ia(n+1)/ja(ia(n+1)-1)/aa(ia(n+1)-1) input matrix in cs format.
!   oo  ib(n+1)/jb(ib(n+1)-1)/kb(ib(n+1)-1)/ab(ib(n+1)-1)
!         output matrix in ds format.
!
      subroutine csr2dsc_mod(n,ia,ja,aa, &
        ic,jc,kc,ac,max_c,ir,jr,kr,max_r, &
        iendru,iendlu,lsize,ierr)
!
! parameters
!
      implicit none
      integer n,max_r,max_c,lsize,ierr
      integer ia(*),ja(*)
      double precision aa(*)
      integer, allocatable :: ir(:),jr(:),kr(:),ic(:),jc(:),kc(:)
      double precision, allocatable :: ac(:)
      integer iendru,iendlu
!
! interfaces
!
!
! internals
!
      integer, allocatable, dimension(:) :: wn01
      integer i,j,k,l,jstrt,jstop,max_r_org,max_c_org,jj
      integer izero,newmax_r,newmax_c,istrt,istop,itemp,incr,incc
      integer ind
      double precision one
      parameter(izero=0,one=1.0d0)
!
! start of csr2dsc
!
!  -- allocation
!
      allocate(wn01(n+1),stat=ierr)
      if(ierr.ne.0) call serr(0,2,'sparslab','cs2ds2', &
        ' allocation error',8,2)
!
!  -- check max_r and max_c with respect to embedding of the
!  -- input matrix
!
      max_r_org=max_r
      max_c_org=max_c
      itemp=3*ia(n+1)-1
      max_r=max(max_r,itemp)
      max_c=max(max_c,itemp)
!
!  -- second check with respect to lsize
!
      max_r=max(max_r,ia(n+1)-1+n*lsize+1)
      max_c=max(max_c,ia(n+1)-1+n*lsize+1)
!
!  -- check for reallocation
!
      if(max_r_org.lt.max_r) then
!        call getincr(n,1,0,incr)
        incr=min(max_r,incr)
        incr=max(max_r-max_r_org,incr)
        if(incr.gt.0) then
          call realli_a(jr,max_r_org,incr,newmax_r,ierr)
          max_r=newmax_r
        end if
      end if
      if(max_c_org.lt.max_c) then
!        call getincr(n,1,0,incc)
        incc=min(max_r,incc)
        incc=max(max_c-max_c_org,incc)
        if(incc.gt.0) then
          call realli_a(jc,max_c_org,incc,newmax_c,ierr)
          call reallr_a(ac,max_c_org,incc,newmax_c,ierr)
          max_c=newmax_c
        end if
      end if
!
!  -- clear vectors for row and column indices
!
      call iwset(max_r-1,izero,jr,1)
      jr(max_r)=1
      call iwset(max_c-1,izero,jc,1)
      jc(max_c)=1
!
!  -- set row pointers
!
      k=1
      ind=0
      ir(1)=1
      do i=1,n
        jstrt=ia(i)
        jstop=ia(i+1)-1
        do j=jstrt,jstop
          l=ja(j)
          ind=ind+1
          jr(ind)=l
        end do
        kr(i)=jstop-jstrt+1
        ir(i+1)=ind+lsize
        ind=ind+lsize-1
      end do
      iendru=ir(n+1)-1
!
!  -- set column pointers (assumed ordering of matrix indices)
!  -- this is something like direct transposition of the input
!  -- matrix into dsc format.
!
      k=1
      ind=0
      ic(1)=1
      call iwset(n,0,wn01,1)
      call iwset(n,0,kc,1)
!
!  -- compute counts of rows
!
      jstrt=1
      do i=2,n+1
        jstop=ia(i)
        do j=jstrt,jstop-1
          jj=ja(j)
          wn01(jj)=wn01(jj)+1
        end do
        jstrt=jstop
      end do
!
!  -- get column pointers
!
      istrt=1
      ic(1)=istrt
      do j=1,n
        istop=istrt+wn01(j)
        ic(j+1)=istop+lsize
        wn01(j)=istrt
        istrt=istop+lsize
      end do
!
!  -- move the data
!
      do i=1,n
        jstrt=ia(i)
        jstop=ia(i+1)-1
        do j=jstrt,jstop
          jj=ja(j)
          k=wn01(jj)
          jc(k)=i
          ac(k)=aa(j)
          wn01(jj)=wn01(jj)+1
          kc(jj)=kc(jj)+1
        end do
      end do
      iendlu=ic(n+1)-1
!
!  -- deallocation
!
      deallocate(wn01)
!
!  -- return
!
      return
!
! end of csr2dsc_mod
!
      end subroutine csr2dsc_mod



! (c) sparslab module name=csr2sc3_mod
!
! purpose:
!  matrix conversion from csr format
!  into dsc format with no sufficient elbow space.
!  lengths of rows are not set up.
!
! history:
!   original version for sparslab - tu - 09/11/1996.
!
! parameters:
!
      subroutine csr2dsc3_mod(n,ia,ja,ic,jc,ac,max_c,ir,jr,max_r,info)
!
! parameters
!
      integer n,max_c,max_r,info
      integer :: ia(*),ja(*)
      integer, allocatable, dimension(:) :: ir,jr,ic,jc
      double precision, allocatable, dimension(:) :: ac
!
!
! internals
!
      integer, allocatable, dimension(:) :: wn01
      integer i,j,k,l,jstrt,jstop,incr,incc,newmax_r,newmax_c,itemp
      integer max_c_org,max_r_org,ierr
      double precision zero,one
      parameter(zero=0.0d0,one=1.0d0)
!
! start of csr2sc3_mod
!
!  -- allocation
!
      allocate(wn01(n+1),stat=ierr)
      if(ierr.ne.0) go to 400
!
!  -- check max_r and max_c with respect to embedding of the
!  -- input matrix
!
      max_r_org=max_r
      max_c_org=max_c
      itemp=ia(n+1)
      max_r=itemp
      max_c=itemp
!
!  -- check for reallocation
!
      if(max_r_org.lt.max_r) then
        incr=max_r-max_r_org
        call realli_a(jr,max_r,incr,newmax_r,ierr)
        max_r=newmax_r
      end if
      if(max_c_org.lt.max_c) then
        incc=max_c-max_c_org
        call realli_a(jc,max_c,incc,newmax_c,ierr)
        call reallr_a(ac,max_c,incc,newmax_c,ierr)
        max_c=newmax_c
      end if
!
! initialization
!
      call iwset(n,0,wn01,1)
      call dinit(max_c,zero,ac,1)
!
!  -- set up row pointers
!  -- and insert row structure of the upper triangle of the original matrix
!
      k=1
      do i=1,n
        ir(i)=k
        jstrt=ia(i)
        jstop=ia(i+1)-1
        do j=jstrt,jstop
          l=ja(j)
          if(l.ge.i) then
            wn01(l)=wn01(l)+1
            jr(k)=l
            k=k+1
          end if
        end do
      end do
!
!  -- set up column data structure
!
      ic(1)=1
      k=1
      do i=1,n
        ic(i+1)=k+wn01(i)
        k=ic(i+1)
      end do
      do i=1,n
        k=ic(i)
        ac(k)=one
        wn01(i)=k+1
      end do
!
      do i=1,n
        jstrt=ia(i)
        jstop=ia(i+1)-1
        do j=jstrt,jstop
          l=ja(j)
          if(l.eq.i) then
            k=ic(i)
            jc(k)=l
          elseif(l.gt.i) then
            k=wn01(l)
            jc(k)=i
            wn01(l)=k+1
          end if
        end do
      end do
!
!  -- deallocation
!
      deallocate(wn01)
!
!  -- return
!
      return
!
 400  continue
      info=8
      return
!
! end csr2sc3_mod
!
      end subroutine csr2dsc3_mod


!
      end module matrix90



      module ptools_mod
!
      use system_mod
!
      contains
!
!


! (c) sparslab module name=aicol2
! purpose:
!   modify a pivot for sparse approximate inverse preconditioner ainv,
!   invert dv1
!   get a column vector wn03/wr03(1..ind3) and scale
!   a row vector wn02/wr02(1..ind2) by dv1.
!   these operations correspond to initialization
!   before sparse rank-1 update in each step
!   of the approximate inverse preconditioner procedure
!   if diag_one=1 then scale column z_i by sqrt(pivot_i)
!
! history:
!   original version for sparslab - tu - 12/04/1996.
!
! parameters:
!
      subroutine aicol2(ptc,lenc,cnc,h,wn03,wr03,ind3, &
        wr02,ind2,indexc,dv1,diagtol,imodif)
!
! parameters
!
      implicit none
      integer :: ptc(*),lenc(*),cnc(*)
      double precision :: h(*)
      integer wn03(*)
      double precision wr02(*),wr03(*)
      double precision dv1,diagtol
      integer, intent(inout) :: ind2
      integer :: ind3,indexc,imodif
!
! internals
!
      integer istrt,istop,i
      double precision zero,temp,temp1,one
      logical never
      parameter(zero=0.0d0,one=1.0d0,never=.false.)
!
! start of aicol2
!
      istrt=ptc(indexc)
      istop=istrt+lenc(indexc)-1
!
!  -- test dv1 - if dv1 too small then modify
!  -- get vector wn03/wr03(1..ind3)
!
      ind3=0
      if(dv1.lt.diagtol) then
        imodif=imodif+1
        dv1=max(abs(dv1),diagtol)
      end if
      do i=istrt,istop
        ind3=ind3+1
        wn03(ind3)=cnc(i)
        wr03(ind3)=h(i)
      end do
!
!  -- invert dv1
!
      dv1=one/dv1
!
!  -- scale the pivot column
!
      ind3=0
      temp=sqrt(dv1)
      dv1=temp
      do i=istrt,istop
        ind3=ind3+1
        h(i)=h(i)*temp
        wr03(ind3)=h(i)
      end do
!
!  -- scale the vector wn02/wr02(1..ind2)
!
      do i=1,ind2
        wr02(i)=wr02(i)*dv1
      end do
!
!  -- return
!
      return
!
! end of aicol2
!
      end subroutine aicol2



! (c) sparslab module name=ainrrow2
!
! purpose:
!   Find z_{indexr}^t*A^t*A*z^{(indexr-1)}[indexr, ..., n]
!   for right-looking SAINV-based preconditioners for normal equations
!   The code does not use A^TA
!   The formula correponds to Algorithm 3.1. in
!   Benzi, Cullum, Tuma, 2000
!   Sparse vector (ind2,wn02,wr02) on output.
!   (version avoiding normal squaring)
!
! history:
!   original version for sparslab - tu - 29-03-96.
!   updated - tu - 18/5/1999; 08/2014
!
! parameters:
!
      subroutine ainrrow2(m,n,ia,ja,a,iat,jat,aat, &
        ptc,lenc,cnc,h,ptr,lenr,cnr, &
        wn01,wr01,wn02,wr02,wn03,wn04,wn06,wr05, &
        ind2,indexr,dv1,drfl,ierr)
!
      integer, intent(in) :: m,n
      integer, intent(in) :: ia(m+1) ! row pointers for A
      integer, intent(in) :: iat(n+1) ! row pointers for A^T
      integer, intent(in) :: ja(ia(m+1)-1) ! column indices for A
      integer, intent(in) :: jat(iat(n+1)-1) ! column indices for A^T
      double precision, intent(in) :: a(ia(m+1)-1) ! entries of A
      double precision, intent(in) :: aat(iat(n+1)-1) ! entries of A^T
      double precision, intent(in) :: drfl
      integer, intent(in) ::  cnc(*),cnr(*)
      integer, intent(in) ::  ptc(*),ptr(*)
      integer, intent(in) :: lenc(*),lenr(*)

      double precision, intent(in) :: h(*)
      integer, intent(in) :: indexr
      integer, intent(out) :: ind2
      integer, intent(out) :: ierr ! error flag

      integer wn01(*)
      double precision, intent(inout) :: wr01(*)
        ! set to zero on entry and reset on exit
      double precision, intent(inout) :: wr05(*)
        ! set to zero on entry and reset on exit
      integer, intent(inout) :: wn04(*)
        ! set to 0 on entry and reset on exit
      integer wn02(*),wn03(*)
      integer wn06(*)
      double precision wr02(*)
!
! internals
!
      integer i,j,k,i1,ii,l,jj,ind5,ind7
      integer ind3,ind
      integer indk,jstrt,jstop,istrt,istop
      double precision zero,dv1,sum,mi,mifl
      parameter(zero=0.0d0)
      parameter(mi=0.1d0)

!
! start of ainrrow2
!
      ind3=0
      indk = 0
      ierr = 0
!
!     A * z_{indexr}^{(i-1)}
!     this operation uses A stored by columns (iat,jat,aat)
!     result in: ind3 : count of nonzeros
!                wn03(1:ind3) : indices
!                wr01(wn03(1:ind3)) : values - indirectly mapped
!                wn04 is an auxiliary vector that is reinitialized
!
      istrt=ptc(indexr) ! indexr is current column
                         ! it can be just the nit-th column but it can
                         ! be even more general
      istop=ptc(indexr)+lenc(indexr)-1
      ! loop over row indexr
      do i=istrt,istop
        ii=cnc(i)
        ! loop over entries of row ii of A^T
        jstrt=iat(ii)
        jstop=iat(ii+1)-1
        do j=jstrt,jstop
          k=jat(j)
          l=wn04(k)
          if(l.eq.0) then
            ! first encounter of col. k in A^T.
            ! increment intersection count. compute and store entry
            ind3=ind3+1
            wr01(k)=h(i)*aat(j)
            wn04(k)=ind3
            wn03(ind3)=k
          else
            ! col. k already encountered. update entry
            wr01(k)=wr01(k)+h(i)*aat(j)
          end if
        end do
      end do
!
      ! reset wn04 to 0
      do i=1,ind3
        j=wn03(i)
        wn04(j)=0
      end do
!
!     A^T*(A * z_{indexr}^{(i-1)})
!     that is A^T*the vector in ind3,wn03,wr01 computed above
!     this operation uses A stored by rows (ia,ja,aa)
!     result in: ind5 : count of nonzeros
!                wn06(1:ind5) : indices
!                wr05(wn06(1:ind5)) : values - indirectly mapped
!                wn04 is an auxiliary vector that is reinitialized
!
      istrt=1
      istop=ind3
      ind5=0
      do i=1,ind3
        ii=wn03(i)
        ! loop over entries of row ii of A
        jstrt=ia(ii)
        jstop=ia(ii+1)-1
        do j=jstrt,jstop
          k=ja(j)
          l=wn04(k)
          if(l.eq.0) then
            ! first encounter of col. k in A
            ind5=ind5+1
            wr05(k)=wr01(ii)*a(j)
            wn04(k)=ind5
            wn06(ind5)=k
          else
            wr05(k)=wr05(k)+wr01(ii)*a(j)
          end if
        end do
      end do
      ! reset wn04 to 0 and wr05 to 0.0
      do i=1,ind5
        j=wn06(i)
        wn04(j)=0
        wr05(j)=zero
      end do
!
!     Funny story: the computed product is kept only symbolically
!     and wr05 is freed for other intermediate products
!     question: do we really need to have it (except for possible dropping)?
!
!     Now, columns that should be updated in the right-looking loop
!     are symbolically evaluated and put into ind2, wn02
!     Once we have this, the bilinear form can be computed symetrically!
!
      ind2=0
      do i=1,ind5
        j=wn06(i)
        jstrt=ptr(j)
        jstop=jstrt+lenr(j)-1
        do j=jstrt,jstop
          k=cnr(j)
          if(wn01(k).eq.0) then
            wn01(k)=j
            ind2=ind2+1
            wn02(ind2)=k
            if(k.eq.indexr) indk=ind2
          end if
        end do
      end do
!
!     What to do here? This means that A^TA is rank-deficient
!     Shift? Modification? Let us keep this open for now.
!
      !!!! return an error if pivot not found.
      if (indk.eq.0) then
         ierr =  -1
         return
      end if
!
!     Get products z^T*A^T fr those columns that will be updated
!     Put them into ind7,wn06,wr05 and multiply with the entries
!     in wr01 (dot product). The result goes into wr02!!!
!
      do i1=1,ind2
        ind7=0
        jj=wn02(i1)
        wn01(jj)=0
        istrt=ptc(jj)
        istop=ptc(jj)+lenc(jj)-1
        do i=istrt,istop
          ii=cnc(i)
          jstrt=iat(ii)
          jstop=iat(ii+1)-1
          do j=jstrt,jstop
            k=jat(j)
            l=wn04(k)
            if(l.eq.0) then
              ind7=ind7+1
              wr05(k)=h(i)*aat(j)
              wn04(k)=ind7
              wn06(ind7)=k
            else
              wr05(k)=wr05(k)+h(i)*aat(j)
            end if
          end do
        end do
        sum=zero
        do i=1,ind7
          j=wn06(i)
          if(wr01(j).ne.zero) then
            sum=sum+wr01(j)*wr05(j)
          end if
         ! reset wn04 to 0 and wr05 to 0.0
          wr05(j)=zero
          wn04(j)=0
        end do
        wr02(i1)=sum
      end do
!
      ! reset wr01 to zero
      do i=1,ind3
        j=wn03(i)
        wr01(j)=zero
      end do
!
!  -- get the diagonal pivot dv1
!
      dv1=wr02(indk)
!
!  -- remove the pivot index/entry from the list
!  -- wr02(1..ind2)
!
      wn02(indk)=wn02(ind2)
      wr02(indk)=wr02(ind2)
      ind2=ind2-1
!
!  -- remove small elements
!
      ind=0
      mifl=mi*drfl
      do i=1,ind2
        if(abs(wr02(i)).ge.mifl) then
          ind=ind+1
          wr02(ind)=wr02(i)
          wn02(ind)=wn02(i)
        end if
      end do
      ind2=ind
!
!  -- return
!
      return
!
! end of ainrrow2
!
      end subroutine ainrrow2


! (c) sparslab module name=ainrrow3
!
! purpose:
!   Find z_{indexr}^t*A^t*A*z^{(indexr-1)}[indexr, ..., n]
!   for right-looking SAINV-based preconditioners for normal equations
!   The code does not use A^TA
!   The formula correponds to Algorithm 3.1. in
!   Benzi, Cullum, Tuma, 2000
!   Sparse vector (ind2,wn02,wr02) on output.
!   (version avoiding normal squaring)
!   diagonal entries modified by adding alpha&I
!
!
      subroutine ainrrow3(m,n,ia,ja,a,iat,jat,aat, &
        ptc,lenc,cnc,h,ptr,lenr,cnr, &
        wn01,wr01,wn02,wr02,wn03,wn04,wn06,wr05,wn07, &
        ind2,indexr,dv1,drfl,alphan,ierr)
!
      integer, intent(in) :: m,n
      integer, intent(in) :: ia(m+1) ! row pointers for A
      integer, intent(in) :: iat(n+1) ! row pointers for A^T
      integer, intent(in) :: ja(ia(m+1)-1) ! column indices for A
      integer, intent(in) :: jat(iat(n+1)-1) ! column indices for A^T
      double precision, intent(in) :: a(ia(m+1)-1) ! entries of A
      double precision, intent(in) :: aat(iat(n+1)-1) ! entries of A^T
      double precision, intent(in) :: drfl,alphan
      integer, intent(in) ::  cnc(*),cnr(*)
      integer, intent(in) ::  ptc(*),ptr(*)
      integer, intent(in) :: lenc(*),lenr(*)

      double precision, intent(in) :: h(*)
      integer, intent(in) :: indexr
      integer, intent(out) :: ind2
      integer, intent(out) :: ierr ! error flag

      integer wn01(*)
      double precision, intent(inout) :: wr01(*)
        ! set to zero on entry and reset on exit
      double precision, intent(inout) :: wr05(*)
        ! set to zero on entry and reset on exit
      integer, intent(inout) :: wn04(*)
        ! set to 0 on entry and reset on exit
      integer wn02(*),wn03(*)
      integer wn06(*),wn07(*)
      double precision wr02(*)
!
! internals
!
      integer i,j,k,i1,ii,l,jj,ind5,ind7
      integer ind3,ind
      integer indk,jstrt,jstop,istrt,istop
      double precision zero,dv1,sum,mi,mifl,diag
      parameter(zero=0.0d0)
      parameter(mi=0.1d0)

!
! start of ainrrow3
!
      ind3=0
      indk = 0
      ierr = 0
!
!     A * z_{indexr}^{(i-1)}
!     this operation uses A stored by columns (iat,jat,aat)
!     result in: ind3 : count of nonzeros
!                wn03(1:ind3) : indices
!                wr01(wn03(1:ind3)) : values - indirectly mapped
!                wn04 is an auxiliary vector that is reinitialized
!
      istrt=ptc(indexr) ! indexr is current column
                         ! it can be just the nit-th column but it can
                         ! be even more general
      istop=ptc(indexr)+lenc(indexr)-1
      ! loop over row indexr
      do i=istrt,istop
        ii=cnc(i)
        ! loop over entries of row ii of A^T
        wn07(ii)=i
        jstrt=iat(ii)
        jstop=iat(ii+1)-1
        do j=jstrt,jstop
          k=jat(j)
          l=wn04(k)
          if(l.eq.0) then
            ! first encounter of col. k in A^T.
            ! increment intersection count. compute and store entry
            ind3=ind3+1
            wr01(k)=h(i)*aat(j)
            wn04(k)=ind3
            wn03(ind3)=k
          else
            ! col. k already encountered. update entry
            wr01(k)=wr01(k)+h(i)*aat(j)
          end if
        end do
      end do
!
      ! reset wn04 to 0
      do i=1,ind3
        j=wn03(i)
        wn04(j)=0
      end do
!
!     A^T*(A * z_{indexr}^{(i-1)})
!     that is A^T*the vector in ind3,wn03,wr01 computed above
!     this operation uses A stored by rows (ia,ja,aa)
!     result in: ind5 : count of nonzeros
!                wn06(1:ind5) : indices
!                wr05(wn06(1:ind5)) : values - indirectly mapped
!                wn04 is an auxiliary vector that is reinitialized
!
      istrt=1
      istop=ind3
      ind5=0
      do i=1,ind3
        ii=wn03(i)
        ! loop over entries of row ii of A
        jstrt=ia(ii)
        jstop=ia(ii+1)-1
        do j=jstrt,jstop
          k=ja(j)
          l=wn04(k)
          if(l.eq.0) then
            ! first encounter of col. k in A
            ind5=ind5+1
            wr05(k)=wr01(ii)*a(j)
            wn04(k)=ind5
            wn06(ind5)=k
          else
            wr05(k)=wr05(k)+wr01(ii)*a(j)
          end if
        end do
      end do
      ! reset wn04 to 0 and wr05 to 0.0
      do i=1,ind5
        j=wn06(i)
        wn04(j)=0
        wr05(j)=zero
      end do
!
!     Funny story: the computed product is kept only symbolically
!     and wr05 is freed for other intermediate products
!     question: do we really need to have it (except for possible dropping)?
!
!     Now, columns that should be updated in the right-looking loop
!     are symbolically evaluated and put into ind2, wn02
!     Once we have this, the bilinear form can be computed symetrically!
!
      ind2=0
      do i=1,ind5
        j=wn06(i)
        jstrt=ptr(j)
        jstop=jstrt+lenr(j)-1
        do j=jstrt,jstop
          k=cnr(j)
          if(wn01(k).eq.0) then
            wn01(k)=j
            ind2=ind2+1
            wn02(ind2)=k
            if(k.eq.indexr) indk=ind2
          end if
        end do
      end do
!
!     What to do here? This means that A^TA is rank-deficient
!     Shift? Modification? Let us keep this open for now.
!
      !!!! return an error if pivot not found.
      if (indk.eq.0) then
         ierr =  -1
         return
      end if
!
!     Get products z^T*A^T for those columns that will be updated
!     Put them into ind7,wn06,wr05 and multiply with the entries
!     in wr01 (dot product). The result goes into wr02!!!
!
      do i1=1,ind2
        ind7=0
        jj=wn02(i1)
        wn01(jj)=0
        istrt=ptc(jj)
        istop=ptc(jj)+lenc(jj)-1
        diag=zero
        do i=istrt,istop ! loop because of the diagonal modification
          ii=cnc(i)
          if(wn07(ii) /= 0) diag=diag+h(wn07(ii))*h(i)
        end do
        do i=istrt,istop
          ii=cnc(i)
          jstrt=iat(ii)
          jstop=iat(ii+1)-1
          do j=jstrt,jstop
            k=jat(j)
            l=wn04(k)
            if(l.eq.0) then
              ind7=ind7+1
              wr05(k)=h(i)*aat(j)
              wn04(k)=ind7
              wn06(ind7)=k
            else
              wr05(k)=wr05(k)+h(i)*aat(j)
            end if
          end do
        end do
        sum=zero
        do i=1,ind7
          j=wn06(i)
          if(wr01(j).ne.zero) then
            sum=sum+wr01(j)*wr05(j)
          end if
         ! reset wn04 to 0 and wr05 to 0.0
          wr05(j)=zero
          wn04(j)=0
        end do
        sum=sum+alphan*diag ! modification
        wr02(i1)=sum
      end do
!
      ! reset wr01 to zero
      do i=1,ind3
        j=wn03(i)
        wr01(j)=zero
      end do
!
!  -- get the diagonal pivot dv1
!
      dv1=wr02(indk)
!
!  -- remove the pivot index/entry from the list
!  -- wr02(1..ind2)
!
      wn02(indk)=wn02(ind2)
      wr02(indk)=wr02(ind2)
      ind2=ind2-1
!
!  -- remove small elements
!
      ind=0
      mifl=mi*drfl
      do i=1,ind2
        if(abs(wr02(i)).ge.mifl) then
          ind=ind+1
          wr02(ind)=wr02(i)
          wn02(ind)=wn02(i)
        end if
      end do
      ind2=ind
!
!  -- clear wn07
!
      istrt=ptc(indexr)
      istop=ptc(indexr)+lenc(indexr)-1
      do i=istrt,istop
        wn07(cnc(i))=0
      end do
!
!  -- return
!
      return
!
! end of ainrrow3
!
      end subroutine ainrrow3


!
      end module ptools_mod



      module rank1
!
      use system_mod
      use ptools_mod
      use matrix90
!
      contains
!
!


! (c) sparslab module name=rank1n2_mod
!
! purpose:
!   sparse rank-one update in dynamic data structures.
!   it updates a submatrix given by row indices
!   wn03(1..ind3) and column indices wn02(1..ind2)
!   and removes pivot column indexk and row indexj
!   from the row data structures.
!   nonsymmetric version.
!   removes processed columns from dynamic data structures.
!   advantageous for such algorithms which will not use these
!   columns later (like rif et al.)
!
!   vector wn03/wr03(1..ind3) corresponds to a pivot column.
!   input matrix is stored in the dynamic data structures
!   cnr,ptr,lenr/cnc,ptc,lenc
!
! history:
!   original version for sparslab - tu - 01/05/2001.
!   based on the codes sig.f, nig.f, aig.f, ainvupd1.f
!
      subroutine rank1n2_mod(scrlvl,n,m,ptr,cnr,lenr, &
        max_r,ptc,cnc,lenc,h,max_c, &
        indexk,wr01,wn03,wr03,ind3,wn02,wr02,ind2, &
        iendru,iendlu,drfl,nit,if2,idist,garcol,garrow,droptyp, &
        nreallocr,nreallocc,ierr,flag)
!
! parameters
!
      integer scrlvl,n,m,droptyp,nreallocr,nreallocc
      integer nit,if2,max_r,max_c
      integer, allocatable :: ptr(:),cnr(:),lenr(:),ptc(:),cnc(:),lenc(:)
      double precision, allocatable :: h(:)
      integer iendru,iendlu,nrow,garrow,garcol,indexk,ind2,ind3
      integer idist,ierr,flag
      integer wn02(*),wn03(*)
      double precision wr01(*),wr02(*),wr03(*),temp
      double precision drfl
!
! internals
!
      integer istrt,istop,ibeg,ncol,i1
      integer i,j,j1,j2,j3,iqcmpr,jstrt,jstop,incr
      integer ll1,k,len,newmax_r,newmax_c,oldmax_r,oldmax_c
      double precision zero,one,drfl_rel,avg_size
      character dropping*8
      parameter (zero=0.0d0,one=1.0d0)
!
!  -- start of rank1n2_mod
!
!  -- set dropping
!
      if(droptyp.eq.0) then
        dropping='absolute'
      elseif(droptyp.eq.1) then
        dropping='relative'
      end if
!
!  -- define new parameters
!
      ibeg=1
!
!  -- remove indexk from the rows
!  -- which intersect column indexk.
!
      istrt=ptc(indexk)
      istop=istrt+lenc(indexk)-1
      do i=istrt,istop
        k=cnc(i)
        jstrt=ptr(k)
        jstop=jstrt+lenr(k)-1
        do j=jstrt,jstop
          if(cnr(j).eq.indexk) then
            cnr(j)=cnr(jstop)
            cnr(jstop)=0
            lenr(k)=lenr(k)-1
            exit
          end if
        end do
      end do
!
!  -- main loop for columns with indices from wn02(1..ind2)
!
      do ll1=1,ind2
!
!    -- get index of the updated column and
!    -- corresponding column value of the rank-1 matrix
!
        ncol=wn02(ll1)
        temp=wr02(ll1)
!
!    -- scatter and scale the pivot column from wr03 into wr01
!
        do i=1,ind3
          j=wn03(i)
          wr01(j)=-wr03(i)*temp
        end do
!
!    -- define start and end of the column ncol
!
        istrt=ptc(ncol)
        istop=istrt+lenc(ncol)-1
!
!    -- compute average size of an original nonzero
!    -- for relative dropping
!
        if(dropping.eq.'relative') then
          avg_size=zero
          do j=istrt,istop
            temp=h(j)
            avg_size=avg_size+abs(temp)
          end do
          len=istop-istrt+1
          if(len.ne.0) then
            avg_size=avg_size/dble(len)
          end if
        end if
!
!    -- get drop tolerance
!
        if(dropping.eq.'relative') then
          drfl_rel=drfl*avg_size
        else
          drfl_rel=drfl
        end if
!
!    -- update existing entries of the column ncol
!
        do j=istrt,istop
          k=cnc(j)
          if(wr01(k).ne.zero) then
!
!        -- update
!
            h(j)=h(j)+wr01(k)
            wr01(k)=zero
            if(abs(h(j)).lt.drfl_rel) then
!
!          -- mark the value which is to be dropped
!
              cnc(j)=0
!
!          -- define start and end of the corresponding row list
!
              jstrt=ptr(k)
              jstop=jstrt+lenr(k)-1
!
!          -- find index ncol in the row list corresponding
!          -- to an entry to be dropped
!
              do i1=jstrt,jstop
                if(cnr(i1).eq.ncol) then
!
!              -- index found
!
                  cnr(i1)=cnr(jstop)
                  cnr(jstop)=0
                  lenr(k)=lenr(k)-1
!
!              -- jump outside
!
                  go to 204
                end if
              end do
 204 &
             continue
            end if
          end if
        end do
!
! -- remove marked candidates to be dropped
! -- shrink remaining entries in the column ncol between
! -- istrt and istop
!
        i=istrt
        do j=istrt,istop
          if(cnc(j).eq.0) then
            if2=if2-1
            go to 220
          else
            cnc(i)=cnc(j)
            h(i)=h(j)
            i=i+1
          end if
 220 &
         continue
        end do
        lenc(ncol)=i-istrt
        do j=i,istop
          cnc(j)=0
        end do
        istop=i-1
!
!    -- insert fill-in into column ncol
!
        do 80 i=1,ind3
          nrow=wn03(i)
!
!      -- test fill-in size
!
          if(abs(wr01(nrow)).gt.drfl_rel) then
!
!        -- look for a free space at the beginning of a column list
!
            if(istrt.gt.1) then
              if(cnc(istrt-1).eq.0) then
!
!            -- add a the new entry at the beginning of the column list
!
                istrt=istrt-1
                cnc(istrt)=nrow
                h(istrt)=wr01(nrow)
                lenc(ncol)=lenc(ncol)+1
                ptc(ncol)=ptc(ncol)-1
                if2=if2+1
                go to 550
              end if
            endif
!
!        -- look for a free space at the end of a column list
!
 400 &
            continue
            if(cnc(istop+1).eq.0) then
!
!          -- add a new element at the end of a column list
!
              iqcmpr=0
              istop=istop+1
              cnc(istop)=nrow
              h(istop)=wr01(nrow)
              if2=if2+1
              iendlu=max(iendlu,istop)
              lenc(ncol)=lenc(ncol)+1
            else
              j1=istop-istrt+1
              if((iendlu+j1).lt.max_c-1) then
!
!            -- copy a column at the current end
!            -- of the column working space
!
                j2=istrt-1-iendlu
                do j=iendlu+1,iendlu+j1
                  j3=j2+j
                  cnc(j)=cnc(j3)
                  h(j)=h(j3)
                  cnc(j3)=0
                end do
                iqcmpr=0
                istrt=iendlu+1
                ptc(ncol)=istrt
                istop=iendlu+j1
                cnc(istop+1)=0
                go to 400
              else
!
!            -- garbage collection of the column working space
!
                if(iqcmpr.eq.1.or.  &
                   (dble(iendlu)/dble(nit))*dble(n).gt.max_c) then
!
!              -- reallocation of cnc,h
!
                  oldmax_c=max_c
                  incr=min(max_c,int(0.5d0*(n*n-nit*(nit-1)/2)))
                  incr=int(min(real(max_c,8),0.5_8*(real(n,8)*real(n,8) &
                       - real(nit,8)*(real(nit,8)-1.0_8)/2)))
                  call realli_a(cnc,max_c,incr,newmax_c,ierr)
                  call reallr_a(h,max_c,incr,newmax_c,ierr)
                  max_c=newmax_c
                  nreallocc=nreallocc+1
                  call iwset1(max_c-oldmax_c+1,0,cnc,1,oldmax_c)
                  cnc(max_c)=1
                end if
                iqcmpr=1
                garcol=garcol+1
                if(scrlvl.gt.0) then
                  write(*,*) ' column garbage collection no.',garcol
                end if
                call garclds(n,ptc,cnc,lenc,h,max_c, &
                  ibeg,iendlu,nit,idist)
                istrt=ptc(ncol)
                istop=istrt+lenc(ncol)-1
                go to 400
              end if
            end if
 550 &
            continue
!
!        -- add a new index ncol into a row list corresponding to
!        -- the new fill-in position nrow
!
            jstrt=ptr(nrow)
            jstop=jstrt+lenr(nrow)-1
!
!        -- look for a free space at the beginning of a row list
!
            if(jstrt.gt.1) then
              if(cnr(jstrt-1).eq.0) then
!
!            -- add a new element at the beginning of a row list
!
                jstrt=jstrt-1
                cnr(jstrt)=ncol
                lenr(nrow)=lenr(nrow)+1
                ptr(nrow)=ptr(nrow)-1
                go to 450
              end if
            endif
!
!          -- look for a free space at the end of a row list
!
 440 &
            continue
            if(cnr(jstop+1).eq.0) then
!
!          -- add a new element at the end of a row list
!
              iqcmpr=0
              jstop=jstop+1
              cnr(jstop)=ncol
              iendru=max(iendru,jstop)
              lenr(nrow)=lenr(nrow)+1
            else
!
!          -- copy a row at the current end of the row working space
!
              j1=jstop-jstrt+1
              i1=jstrt-1-iendru
              if((iendru+j1).lt.max_r-1) then
                do 540 j2=1+iendru,j1+iendru
                  j3=i1+j2
                  cnr(j2)=cnr(j3)
                  cnr(j3)=0
 540 &
                continue
                iqcmpr=0
                jstrt=iendru+1
                ptr(nrow)=jstrt
                jstop=iendru+j1
                cnr(jstop+1)=0
                go to 440
              else
!
!            -- garbage collection of the row working space
!
                if(iqcmpr.eq.1.or. &
                   (dble(iendru)/dble(nit))*dble(n).gt.max_r) then
!
!              -- reallocation of cnr
!
                  oldmax_r=max_r
                  incr=min(max_r,int(0.5d0*(n*n-nit*(nit-1)/2)))
                  call realli_a(cnr,max_r,incr,newmax_r,ierr)
                  max_r=newmax_r
                  nreallocr=nreallocr+1
                  call iwset1(max_r-oldmax_r+1,0,cnr,1,oldmax_r)
                  cnr(max_r)=1
                end if
                iqcmpr=1
                garrow=garrow+1
                if(scrlvl.gt.0) then
                  write(*,*) ' row garbage collection no.',garrow
                end if
                call garclds2(m,ptr,cnr,lenr,max_r,ibeg, &
                  iendru,idist)
                jstrt=ptr(nrow)
                jstop=jstrt+lenr(nrow)-1
                go to 440
              end if
            end if
 450 &
            continue
          end if
!
!      -- clear nrow position in wr01
!
          wr01(nrow)=zero
!
!      -- end of fill-in cycle
!
 80  &
        continue
!
!   -- end of loop for columns
!
      end do
!
!  -- remove column indexk
!
      istrt=ptc(indexk)
      istop=istrt+lenc(indexk)-1
      do i=istrt,istop
        cnc(i)=0
      end do
      if2=if2-lenc(indexk)
      lenc(indexk)=0
      ptc(indexk)=1
!
!  -- return
!
      return
!
! end of rank1n2_mod
!
      end subroutine rank1n2_mod



!
      end module rank1



      module rif_mod
!
      use system_mod
      use matrix90
      use rank1
      use ptools_mod
!
      private
      public :: rifsrnr0, rifsr, rifsl3, rifnl, rifsl3s, rifsl4s, rifsvl

!
      contains
!
!




! (c) sparslab module name=rifsl4s
!
! purpose:
!  matrix-free incomplete SPD factorization
!  based on left-looking symmetric SAINV algorithm.
!  preconditioner format is ctt (310).
!
! history:
!   original version for sparslab - tu - 16/06/2000.
!
      subroutine rifsl4s(scrlvl,alphan,m,n,ia,ja,aa, &
        ib,jb,ab,ibt,jbt,abt, max_z, &
        ip,jp,ap,size_p, &
        diagtol,drflic,drflai,lsize,zsize,strategy,imodif, &
        nrealloc,fillai,fillic,dagsize,info)
!
! parameters
!
      implicit none
      integer scrlvl,m,n
      integer :: strategy ! = 0: nested sequential evaluation
                          !      of the needed dot products
                          ! = 1: symbolic evaluation + no pruning
                          ! = 2: symbolic evaluation + simple pruning
                          ! = 3: symbolic evaluation + more complex pruning
                          ! = 4: symbolic/numeric evaluation (not fully tested)
      integer :: lsize,zsize
      integer ia(*),ja(*)
      double precision aa(*)
      integer ib(*),jb(*)
      double precision ab(*)
      integer ibt(*),jbt(*)
      double precision abt(*)
      integer, allocatable :: ip(:),jp(:)
      double precision, allocatable :: ap(:)
      integer max_z,size_p,nrealloc,dagsize
      integer imodif,fillic,info,fillai,iposj
      double precision diagtol,drflic,drflai,alphan
!
! internals
!
      integer, allocatable :: wn01(:),wn02(:),wn03(:)
        ! wn03: only for the A^TA branch
      integer, allocatable :: wia0(:),wn04(:),wn05(:),wn10(:)
      double precision, allocatable :: wr02(:),wr03(:),wr06(:),wr10(:)
      integer, allocatable :: iz(:),jz(:)
      double precision, allocatable :: az(:)
      integer, allocatable :: q(:),wn08(:),symbrow(:),prev(:)
      integer, allocatable :: wn06(:),wn07(:)
      integer, allocatable :: edge(:),pos(:),itemp(:)
      integer :: ipos,indg,iproduct,indpold
!
      double precision zero,one,drflic2,drflai2
      parameter (zero=0.0d0,one=1.0d0)
      integer i,j,k,l,ii,ind2,ind3,istrt,istop,ind4
      integer iendlu,ind,jstrt,jstop,indp,ierr,indp2
      integer lastind,nexti,kk,nflag,pj
      integer tagbase,tag,lsizeloc,largep
      integer nit,szrow,ind6,zsizeloc,largez
      double precision temp1,pi1,pi2,temp
      double precision dv1,pi2x3,drop,pimod,csnormf,nrm
      integer maxtag,indrow,indgmax,indgmax2,ind10
      integer huge_int,incr,newsize_p,newsize_z,flag
      logical :: cloop,column_not_searched,debug
      parameter(maxtag=huge(nit))
      parameter(huge_int=huge(nit))
!
! start of rifsl4s
!
!  -- initialization
!
      info=0
      drflic2=zero
      drflai2=zero
      drflic2=10*drflic
      drflai2=10*drflai
      drflic2=drflic
      drflai2=drflai
      drop=drflic
      imodif=0
      nflag=n+1
      debug=.false.
!
!  -- allocation
!
      if(strategy == 0) then ! explicitly formed A^TA
        allocate(wia0(n+1),wn03(n+1),stat=ierr)
        if(ierr.ne.0) go to 400
        call iwcopy(n,ia,1,wia0,1)
      end if
      indgmax=max(10000,n,m)
      allocate(wn01(m+1),wn02(m+1),stat=ierr)
      if(ierr.ne.0) go to 400
      allocate(wn04(m+1),wn05(m+1),stat=ierr)
      if(ierr.ne.0) go to 400
      allocate(wn06(m),wn07(m),wn10(n),wr10(n),stat=ierr)
      if(ierr.ne.0) go to 400
      allocate(wr02(m+1),wr03(m+1),wr06(m),stat=ierr)
      if(ierr.ne.0) go to 400
!
!  -- allocate reallocatables
!
      allocate(iz(n+1),jz(max_z),az(max_z),stat=ierr)
      if(ierr.ne.0) go to 400
      allocate(ip(n+1),jp(size_p),ap(size_p),stat=ierr)
      if(ierr.ne.0) go to 400
      allocate(wn08(m+1),q(n),symbrow(n),prev(n),stat=ierr)
      if(ierr.ne.0) go to 400
      allocate(pos(indgmax),edge(indgmax),stat=ierr)
      if(ierr.ne.0) go to 400
      do i=1,m
        wn06(i)=0
        wn08(i)=0
      end do
      do i=1,n
        prev(i)=i
        edge(i)=0
        pos(i)=0
      end do
      indg=0
      if(strategy > 0) indg=n
      call iwset(n,nflag,wn01,1)
      call iwset(m,0,wn04,1)
!
!  -- compute auxiliary quantities for diagonal modification
!
      if(alphan /= zero) then
        if(strategy == 0) then   ! modify if the normal matrix is available
          temp=alphan*csnormf(n,ia,aa) ! Frobenius norm
          call moddiag1(n,temp,ia,ja,aa)
        else
          call normf2(m,n,ib,jb,ab,ibt,jbt,abt,wn01,wn02,wr02,nrm)
        end if
      else
        nrm=zero
      end if
      iendlu=0
      iz(1)=1
      ip(1)=1
      indp=1
      indp2=indp
      nit=1
      tagbase=0
      wr02(nflag)=zero
!
!  -- echo
!
      if(scrlvl.ge.1) &
          write(*,*)'... symmetric left looking RIF computation started'
!
!  -- left-looking loop to compute
!     z_{nit}^{nit-1} =
!       z_{nit}^{(0)} - sum_{i=1}^{nit-1}
!                         [(p_{nit}^{(i-1)}/p_i^{(i-1)} z_i^{(i-1)}
!
      write(*,*) 'strategy',strategy
      do while (nit <= n)
!
        if(strategy == 1 .or. strategy == 2 .or. strategy == 3) then ! the row structure should be sorted
                               ! (also for pruning)
          call icrow4(n,pos,edge,nit,ib,jb,ibt,jbt,szrow,symbrow,wn08)
          call uxvsrt(szrow,symbrow)
          indrow=1
        elseif(strategy == 4) then
          call icrow5(n,pos,edge,nit,ib,jb,ab,ibt,jbt,abt, &
            drop,szrow,symbrow,wn08)
          call uxvsrt(szrow,symbrow)
          indrow=1
        end if
        if(strategy /= 0) then
          if(indp+szrow+1.ge.size_p) then
            write(*,*) 'reallocating rif decomposition',indp,size_p
            call getincr(n,nit,size_p,incr,1,ierr)
            incr=max(2*indp,indp+2*szrow)
            incr=size_p+n
            if(ierr.ne.0) go to 400
            call realli_a(jp,size_p,incr,newsize_p,ierr)
            call reallr_a(ap,size_p,incr,newsize_p,ierr)
            size_p=newsize_p
!            write(*,*) 'reallo after size_p',size_p
            nrealloc=nrealloc+1
          end if
        end if
!
        indpold=indp
        lastind=0
        ind3=0
!
!    -- set the initial nit-th basis column
!    -- z_{nit}^{(0)}=e_{nit}
!
        ind2=1
        ind10=0
        wn02(ind2)=nit
        wr02(ind2)=one
        wn01(nit)=ind2
        nexti=nit
        iproduct=0 ! count computed products
!
!
!    -- find the next column of z updating z_{nit}^{(*)}
!
        cloop=.true.
        do while (cloop)
          if(strategy == 0) then ! classical sequential search for the next column
            nexti=nit
            do ii=1,ind2
              j=wn02(ii)
              k=wia0(j)
              column_not_searched=.true.
              do while (column_not_searched)
                if(k.ge.ia(j+1)) then
                  wia0(j)=k
                  column_not_searched=.false.
                else
                  kk=ja(k)
                  if(kk.le.lastind) then
                    l=ia(j)
                    if(k.eq.l) then
                      ind3=ind3+1
                      wn03(ind3)=j
                    end if
                    k=k+1
                  else
                    column_not_searched=.false.
                    wia0(j)=k
                    if(kk.lt.nexti) nexti=kk
                  end if
                end if
              end do
            end do
          elseif(strategy == 1) then ! at this moment we just take the columns from the
                                     ! symbolic decomposition
            if(indrow .le. szrow) then
              nexti=symbrow(indrow)
              indrow=indrow+1
            else
              nexti=n
            end if
          elseif(strategy == 2) then ! at this moment we just take the columns from the
                                     ! symbolic decomposition
            if(indrow .le. szrow) then
              nexti=symbrow(indrow)
              indrow=indrow+1
            else
              nexti=n
            end if
          elseif(strategy == 3) then ! at this moment we just take the columns from the
                                     ! symbolic decomposition
            if(indrow .le. szrow) then
              nexti=symbrow(indrow)
              indrow=indrow+1
            else
              nexti=n
            end if
          end if
!
          if(nexti.lt.nit) then ! update can be done - compute pi2
!
!        -- do the stabilized update using the formulas
!        --   p_{nit}^{(i-1)} = z_i^{(i-1)}^t*a*z_{nit}^{(i-1)} and
!        --   p_i^{(i-1)} = z_i^{(i-1)}^t*a*z_i^{(i-1)}
!
!
!        -- compute into pi2
!        -- p_{nit}^{(i-1)} = z_i^{(i-1)}^t*a*z_{nit}^{(i-1)}
!
            pimod=zero
            if(strategy >= 1) then ! only for the implicit decomposition
              do i=iz(nexti),iz(nexti+1)-1 ! modification of offdiagonals
                j=jz(i)
                if(wn01(j) .ne. nflag) then
                  pimod=pimod+az(i)*wr02(wn01(j))
                end if
              end do
            end if

            if(strategy == 0) then ! A^TA is used as by columns
              ind4=0
              tag=tagbase+nexti
              do i=1,ind2
                ii=wn02(i)
                jstrt=ia(ii)
                jstop=ia(ii+1)-1
                do j=jstrt,jstop
                  k=ja(j)
                  l=wn04(k)
                  if(l.ne.tag) then
                    ind4=ind4+1
                    wr03(ind4)=wr02(i)*aa(j)
                    wn04(k)=tag
                    wn05(k)=ind4
                  else
                    l=wn05(k)
                    wr03(l)=wr03(l)+wr02(i)*aa(j)
                  end if
                end do
              end do
              pi2=zero
              jstrt=iz(nexti)
              jstop=iz(nexti+1)-1
              do j=jstrt,jstop
                ii=jz(j)
                k=wn04(ii)
                if(k.eq.tag) then
                  kk=wn05(ii)
                  pi2=pi2+wr03(kk)*az(j)
                end if
              end do
            elseif(strategy /= 0) then ! implicit use of A^TA based on columns of A
              ind4=0
              tag=tagbase+nexti
              do i=1,ind2
                ii=wn02(i)
                jstrt=ibt(ii)
                jstop=ibt(ii+1)-1
                do j=jstrt,jstop
                  k=jbt(j)
                  l=wn04(k)
                  if(l.ne.tag) then
                    ind4=ind4+1
                    wr03(ind4)=wr02(i)*abt(j)
                    wn04(k)=tag
                    wn05(k)=ind4
                  else
                    l=wn05(k)
                    wr03(l)=wr03(l)+wr02(i)*abt(j)
                  end if
                end do
              end do
              ind6=0   ! wn08 is reused - it must be zeroed
                       ! wn06 should be initialized only at the
                       !   beginning
              jstrt=iz(nexti)
              jstop=iz(nexti+1)-1
              do i=jstrt,jstop
                ii=jz(i)
                jstrt=ibt(ii)
                jstop=ibt(ii+1)-1
                do j=jstrt,jstop
                  k=jbt(j)
                  l=wn06(k)
                  if(l.ne.tag) then
                    ind6=ind6+1
                    wr06(ind6)=az(i)*abt(j)
                    wn06(k)=tag
                    wn07(k)=ind6
                    wn08(ind6)=k
                  else
                    l=wn07(k)
                    wr06(l)=wr06(l)+az(i)*abt(j)
                  end if
                end do
              end do
!
              pi2=zero
              do j=1,ind6
                ii=wn08(j)
                k=wn04(ii)
                if(k.eq.tag) then
                  kk=wn05(ii)
                  pi2=pi2+wr03(kk)*wr06(j)
                end if
              end do
              do i=1,ind6
                wn08(i)=0
              end do
            end if
!
!        -- modify by a multiple of the diagonal of A^TA
!        -- pi2 = z_nexti^T*(A^TA + alphan*I)*z_nexti
!
            pi2=pi2+pimod*alphan*nrm
!
!        -- put an element into rif preconditioner if sufficiently large
!
             if(indp+n.ge.size_p) then
                write(*,*) 'reallocating rif decomposition',indp,size_p
                call getincr(n,nit,size_p,incr,1,ierr)
                incr=size_p+n
                if(ierr.ne.0) go to 400
                call realli_a(jp,size_p,incr,newsize_p,ierr)
                call reallr_a(ap,size_p,incr,newsize_p,ierr)
                size_p=newsize_p
                nrealloc=nrealloc+1
              end if
            if(abs(pi2).ge.drflic) then
              if(lsize > 0) then ! limited memory x unlimited memory
                ind10=ind10+1
                wn10(ind10)=nexti
                wr10(nexti)=pi2
              else
                jp(indp)=nexti
                ap(indp)=pi2
                indp=indp+1
              end if
            end if
!
!        -- perform the update if sufficiently large
!
            if(abs(pi2) .ge. drflic2) then
!
              pi2x3=pi2
!
!          -- the sparse saxpy update
!
              istrt=iz(nexti)
              istop=iz(nexti+1)-1
!
!          -- substract and compute fill-in
!
              ind=0
              do i=istrt,istop
                j=jz(i)
                k=wn01(j)
                if(k.ne.nflag) then
                  temp1=wr02(k)-pi2x3*az(i)
                  wr02(k)=temp1
                else
                  temp1=-pi2x3*az(i)
                end if
                ind=ind+1
                wr03(ind)=temp1
              end do
!
!          -- scan and drop elements of wr02
!
              ind=1
              do i=2,ind2
                temp1=wr02(i)
                j=wn02(i)
                if(abs(temp1).ge.drflai2) then
                  ind=ind+1
                  wr02(ind)=temp1
                  wn02(ind)=j
                  wn01(j)=ind
                else
                  wn01(j)=nflag
                end if
              end do
              ind2=ind
!
!          -- add the fill-in
!
              ind=0
              do i=istrt,istop
                ind=ind+1
                j=jz(i)
                k=wn01(j)
                if(k.eq.nflag) then
                  temp1=wr03(ind)
                  if(abs(temp1).ge.drflai2) then
                    ind2=ind2+1
                    wr02(ind2)=temp1
                    wn02(ind2)=j
                    wn01(j)=ind2
                  else
                    wn01(j)=nflag
                  end if
                end if
              end do
!
            end if
!
!        -- set the lower bound for the search
!
            lastind=nexti
          else
            cloop=.false.
          end if
        end do
!
!    -- reset the starting search pointers
!
        if(strategy == 0) then
          do i=1,ind3
            j=wn03(i)
            wia0(j)=ia(j)
          end do
        end if
!
!    -- at this moment: the update loop for z_{nit} is finished
!
!    -- now: shrink the new entries of RIF between inpold ... indp
!
        lsizeloc=lsize!+ataloc
!        if(ind10 .ne. indp-indp2 .and. lsize > 0) stop 'error ind10'
        if(lsize > 0) then
          if(lsizeloc < ind10) then ! shrink
            largep=ind10-lsizeloc+1
            call split2(ind10,largep,wn10,wr10)
            call srtshai2(lsizeloc,wn10(largep))
          else
            largep=1
          end if
          do i=largep,ind10
            jp(indp2)=wn10(i)
            ap(indp2)=wr10(wn10(i))
            indp2=indp2+1
          end do
          indp=indp2
        end if
!
!    -- reset tags if needed
!
        tag=tagbase+nit
        if(tag.ge.maxtag) then
          call iwset(n,0,wn04,1)
          call iwset(m,0,wn06,1)
          tagbase=0
          tag=nit
        end if
!
!    -- compute the diagonal entry into pi2
!    -- p_{nit}^{(nit-1)} = z_{nit}^{(nit-1)}^t*a*z_{nit}^{(nit-1)}
!
        pimod=zero
        if(strategy /= 0) then ! only for the implicit decomposition
          do i=1,ind2 ! computed also for the smaller entries that will be
                      ! later dropped
            pimod=pimod+wr02(i)*wr02(i)
          end do
        end if

        ind3=0
        if(strategy == 0) then
          do i=1,ind2
            ii=wn02(i)
            jstrt=ia(ii)
            jstop=ia(ii+1)-1
            do j=jstrt,jstop
              k=ja(j)
              l=wn04(k)
              if(l.ne.tag) then
                ind3=ind3+1
                wr03(ind3)=wr02(i)*aa(j)
                wn04(k)=tag
                wn05(k)=ind3
              else
                kk=wn05(k)
                wr03(kk)=wr03(kk)+wr02(i)*aa(j)
              end if
            end do
          end do
          pi1=zero
          do i=1,ind2
            j=wn02(i)
            k=wn04(j)
            if(k.eq.tag) then
              kk=wn05(j)
              pi1=pi1+wr03(kk)*wr02(i)
            end if
          end do
        elseif(strategy /= 0) then ! ibt/jbt/abt should be used
                                   ! since this stores the original
                                   ! matrix A by columns
          do i=1,ind2
            ii=wn02(i)
            jstrt=ibt(ii)
            jstop=ibt(ii+1)-1
            do j=jstrt,jstop
              k=jbt(j)
              l=wn04(k)
              if(l.ne.tag) then
                ind3=ind3+1
                wr03(ind3)=wr02(i)*abt(j)
                wn04(k)=tag
                wn05(k)=ind3
              else
                kk=wn05(k)
                wr03(kk)=wr03(kk)+wr02(i)*abt(j)
              end if
            end do
          end do
          pi1=alphan*pimod*nrm ! modification
          do i=1,ind3
            pi1=pi1+wr03(i)*wr03(i)
          end do
        end if
!
        dv1=pi1
!
!    -- test the diagonal element dv1
!    -- dv1 should be nonnegative and sufficiently large
!
        if(dv1.lt.diagtol) then
          imodif=imodif+1
          temp1=abs(dv1)
          dv1=max(temp1,diagtol)
        end if
!
!    -- put diagonal element into rif preconditioner
!
        jp(indp)=nit
        ap(indp)=one/sqrt(dv1)
        indp=indp+1
!
!    -- update dag
!
        if(strategy == 1 .or. strategy == 2 .or. strategy == 3) then
          j=indp-indpold
          if(indg+j >= indgmax) then ! dag reallocation
            write(*,*) 'reallocation from',indgmax
            incr=indgmax
            indgmax2=indgmax+incr
            allocate(itemp(indg))
            itemp(1:indg)=pos(1:indg)
            deallocate(pos)
            allocate(pos(indgmax2))
            pos(1:indg)=itemp(1:indg)
            itemp(1:indg)=edge(1:indg)
            deallocate(edge)
            allocate(edge(indgmax2))
            edge(1:indg)=itemp(1:indg)
            indgmax=indgmax2
            deallocate(itemp)
          end if
          if(strategy == 1) then ! no pruning
            do i=indpold,indp-1
              j=jp(i)
              if(j.ne.nit) then
                ipos=prev(j)
                indg=indg+1
                pos(ipos)=indg
                edge(indg)=nit
                pos(indg)=0
                prev(j)=indg
              end if
            end do
          elseif(strategy == 2) then ! simple pruning

            do i=indpold,indp-1
              j=jp(i)
              wn04(j)=-1
            end do
            do i=indpold,indp-1
              j=jp(i)
              if(j.ne.nit) then
                ipos=prev(j)
                pj=edge(ipos)
                if(pj.eq.0) then
                  ipos=prev(j)
                  indg=indg+1
                  pos(ipos)=indg
                  edge(indg)=nit
                  pos(indg)=0
                  prev(j)=indg
                else
                  if(pj > j) then
                    if(wn04(pj) .ne. -1) then
                      ipos=prev(j)
                      indg=indg+1
                      pos(ipos)=indg
                      edge(indg)=nit
                      pos(indg)=0
                      prev(j)=indg
                    end if
                  end if
                end if
              end if
            end do
            do i=indpold,indp-1
              j=jp(i)
              wn04(j)=0
            end do
          elseif(strategy == 3) then ! more complex pruning

            do i=indpold,indp-1
              j=jp(i)
              wn04(j)=-1
            end do

            do i=indpold,indp-1
              j=jp(i)
              if(j.ne.nit) then
                flag=0
                iposj=pos(j)
                do while(iposj.ne.0)
                  pj=edge(iposj)
                  if(pj > j) then
                    if(wn04(pj) == -1) then
                      flag=1
                      exit
                    end if
                  end if
                  iposj=pos(iposj)
                end do
                if(flag == 0) then ! add new entry into the dag
                  ipos=prev(j)
                  indg=indg+1
                  pos(ipos)=indg
                  edge(indg)=nit
                  pos(indg)=0
                  prev(j)=indg
                end if
              end if
            end do
            do i=indpold,indp-1
              j=jp(i)
              wn04(j)=0
            end do

          end if
        end if
!
!    -- column scaling in case of square-root algorithm
!
        temp1=one/sqrt(dv1)
        dv1=temp1
!
!    -- shorten Z if zsize > 0
!
        zsizeloc=zsize
        if(zsizeloc < ind2 .and. zsize > 0) then ! shrink
          largez=ind2-zsizeloc+1
          do i=1,ind2
            j=wn02(i)
            wr06(j)=wr02(i)
          end do
          call split2(ind2,largez,wn02,wr06)
          call srtshai2(zsizeloc,wn02(largez))
          do i=largez,ind2
            wr02(i-largez+1)=temp1*wr06(wn02(i))
            wn02(i-largez+1)=wn02(i)
          end do
          ind2=zsizeloc
        else
          do i=1,ind2
            wr02(i)=temp1*wr02(i)
          end do
        end if
!
!    -- column copy
!
        ind=iendlu
        if(iendlu+ind2.gt.max_z) then
          incr=max(max_z+int(max_z/2),iendlu+2*ind2)
          call getincr(n,nit,max_z,incr,1,ierr)
          if(ierr.ne.0) go to 400
          call realli_a(jz,max_z,incr,newsize_z,ierr)
          call reallr_a(az,max_z,incr,newsize_z,ierr)
          max_z=newsize_z
          nrealloc=nrealloc+1
        end if

        do i=1,ind2
          j=wn02(i)
          if(abs(wr02(i)).ge.drflai .or. wn02(i) == nit) then
            ind=ind+1
            jz(ind)=j
            az(ind)=wr02(i)
            wn01(j)=nflag
          else
            wn01(j)=nflag
          end if
        end do
        iendlu=ind
        iz(nit+1)=ind+1
        fillai=ind
        dagsize=indg
!
!    -- echo
!
        if(nit/100.eq.dble(nit)/100.0d0) then
          write(*,*)' nit =',nit, ' fill = ',fillai, ' ',indp
        end if
        ip(nit+1)=indp
        indp2=indp
!
!    -- compare the structures
!
        fillic=indp-1
!
!    -- test the end and update tag base
!
        nit=nit+1
        tagbase=tagbase+n
!
      end do
!
      if (debug) then
        call srtcs1(n,ip,jp,ap)
        open(unit=44,file='dag')
        call odag(44,n,pos,edge)
        close(44)
      end if
!
!  -- deallocation
!
      if(strategy == 0) deallocate(wn03,wia0)
      deallocate(wn01,wn02,wn04,wn05,wr02,wr03)
!
      if(scrlvl.ge.1) &
          write(*,*)'... symmetric left looking RIF computation ended'
!
!  -- return
!
      return
!
  400 continue
!
      ierr=8
!
      return
!
! end of rifsl4s
!
      end subroutine rifsl4s





!
      end module rif_mod

